## CONTEC CPIシリーズ用(RaspberyPi用HATサイズ拡張ボード)IOCを使う前にすること

対応OS,カーネルバージョンは[オンラインヘルプ](https://help.contec.com/pc-helper/api-tool-lnx/jp/APITOOL.htm#t=mergedProjects%2FCAIO%2Fdriver_spec%2Fcommon_linux.htm)を参照。

## デバイスドライバ
メーカー提供のデバイスドライバは以下のURLからダウンロード(要登録)
[API-AIO(LNX)Linux 版 アナログ入出力ドライバ](https://www.contec.com/jp/products-services/daq-control/pc-helper/daq-software/api-aio(lnx)/price/)
[API-DIO(LNX)Linux 用 デジタル入出力デバイスドライバ](https://www.contec.com/jp/products-services/daq-control/pc-helper/daq-software/api-dio(lnx)/price/)

デバイスドライバのコンパイルには、Linuxのカーネルヘッダが必要なので、インストールしておく必要がある。

```
# apt install -y raspberrypi-kernel-headers
```

## デバイス設定
ボードを接続する前に、```/boot/config.txt```を編集して、下記の設定を追加。デバイスドライバからボードが認識されるように設定する。[FAQを参照](https://contec.e-srvc.com/app/answers/detail/a_id/2184/)

```
dtparam=i2c_vc=on
```

デバイスドライバのコンパイルに成功したら、接続したボードの種類とIDを登録する必要がある。
- ボード接続時には、IDが重ならないようにロータリースイッチを設定する。

 AIOとDIOのデバイスドライバをコンパイルしたディレクトリにある```config```ディレクトリに移動し、設定コマンドを実行する。
 以下はAIOの場合、DIOも同様に実行する。
```
# ./config
----------------------------------
CONTEC API-AIO(LNX) Configuration
----------------------------------
Message : Auto detecting devices.
...................................................................................
..
--------------------------------------------------------------------------------
 Devices list
--------------------------------------------------------------------------------
    DeviceName   Product Name       ID              IP/Master IP    Status
[1]:+ AIO000     CPI-AI-1208LI      1
[2]:+ AIO001     CPI-AO-1602LC      0
--------------------------------------------------------------------------------
[#]:Select device       [o]:List sort           [r]:Redetect devices list
[d]:Delete device       [a]:Add device manually [e]:Diagnostic report
[s]:Save settings       [q]:Exit
Please select the device to set up.
Please input >s
********************************************************************************
Save OK?(y/n):y
Message : Setting file is 'contec_aio.conf'.
Message : Start script file is 'contec_aio_start.sh'.
Message : Stop script file is 'contec_aio_stop.sh'.
Confirm(y):y
..
--------------------------------------------------------------------------------
 Devices list
--------------------------------------------------------------------------------
    DeviceName   Product Name       ID              IP/Master IP    Status
[1]:  AIO000     CPI-AI-1208LI      1
[2]:  AIO001     CPI-AO-1602LC      0
--------------------------------------------------------------------------------
[#]:Select device       [o]:List sort           [r]:Redetect devices list
[d]:Delete device       [a]:Add device manually [e]:Diagnostic report
[s]:Save settings       [q]:Exit
Please select the device to set up.
Please input >q
********************************************************************************
```
この設定で表示される```DeviceName```を使ってデバイスドライバにアクセスする。

設定が終了すると、同じディレクトリ内に```contec_Xio_start.sh```(Xはa|d)が作成されるので、デバイスドライバを使用する前に、実行しておくこと。
